-- nscr.lua

-- private

local vars = {str = {}, int = {}}
local errobj = nil
local __nscrerror__ = {}

-- public

module("nscr", package.seeall)

function alias2int(name)
  local value = NSGetIntValue(0)
  NSExec("_mov %0,"..name)
  local result = NSGetIntValue(0)
  NSSetIntValue(0, value)
  return result
end

function alias2str(name)
  local value = NSGetStrValue(0)
  NSExec("_mov $0,"..name)
  local result = NSGetStrValue(0)
  NSSetStrValue(0, value)
  return result
end

function execute(script, level)
  level = level or 2 -- sȏꍇ͌ĂяõxƂB
  if executed then
    -- 2dĂяo͂ł킩邪ANSExec()ŕ⑫ƑG[ƂȂ邽߁AG[͒x点B
    errobj = {
      type = __nscrerror__,
      msg = "NSExec2dɌĂяoƂ͂ł܂B",
      callee = debug.getinfo(2, "Slnf")
    }
    return
  end
  executed = true
  if script:byte(1) <= 127 then
    NSExec(resolve(script, level+1))
  else
    NSExec('puttext "' .. script .. '"')
  end
  if errobj then error(errobj, 0) end
  executed = false
end

executed = false

function seeklocal(target, level)
  level = level or 2 -- ftHg͌Ăяo猟
  local name, value
  while true do
    if not debug.getinfo(level) then break end
    local index = 1
    while true do
      name, value = debug.getlocal(level, index)
      if not name then break end
      if name and name == target then
        return value, level, index
      end
      index = index + 1
    end
    level = level + 1
  end
  return nil
end

function lua_eval(str, beg)
  beg = beg or 1
  local ret = nil
  local level = nil -- [JTp
  -- P̎ʎq̏ꍇ̂݃[JϐeB
  if str:match("^[%l%u]%w*") then
    ret, level = seeklocal(str, beg + 1)
  end
  -- O[õReLXgŕ]B
  if not level then
    ret = loadstring("return "..str)()
  end
  local typ = type(ret)
  while true do
    if typ == "string" then
      return ret
    elseif typ == "number" then
      return ret
    elseif typ == "boolean" then
      return tostring(ret)
    elseif typ == "function" then
      ret = ret()
      typ = type(ret)
    elseif typ == "table" then
      return table.concat(ret, "")
    else
      return ""
    end
  end
end

-- P̎ʎq̏ꍇAR[X^bN烍[J̕ϐTB
-- ȊȌꍇA܂̓[Jϐɖ΃O[õReLXgœǂݍށB
function resolve(script, level)
  level = level or 2 -- sȏꍇ͌ĂяõxƂB
  return string.gsub(script, "#{(.-)}", function(s)
    return lua_eval(s, level+2)
  end)
end

function pop_args(pat)
  local params = {}
  local buf = pat
  table.insert(params, pop_arg(pat:sub(1, 1)))
  buf = pat:sub(2)
  while NSCheckComma() do
    for typ in buf:gmatch("[si#%$%%]") do
      if #params ~= 0 then NSPopComma() end
      table.insert(params, pop_arg(typ))
    end
    buf = pat
  end
  return unpack(params)
end

function pop_arg(typ)
  if typ == "s" then
    return NSPopStr()
  elseif typ == "i" then
    return NSPopInt()
  elseif typ == "#" then
    return NSPopID()
  elseif typ == "$" then
    return NSPopStrRef()
  elseif typ == "%" then
    return NSPopIntRef()
  else
    return nil
  end
end

function setint(var, value)
  local typ = type(value)
  if typ == "string" then
    setint(var, tonumber(value))
    return
  elseif typ == "number" then
    -- as is
  elseif typ == "boolean" then
    setint(var, value and 1 or 0)
    return
  elseif typ == "function" then
    setint(var, value())
    return
  elseif typ == "table" then
    value = #value
  else
    value = 0
  end
  NSSetIntValue(var, value)
end

function getint(var)
  return NSGetIntValue(var)
end

function setstr(var, value)
  local typ = type(value)
  if typ == "string" then
    -- as is
  elseif typ == "number" then
    setstr(var, tostring(value))
    return
  elseif typ == "boolean" then
    setstr(var, tostring(value))
    return
  elseif typ == "function" then
    setstr(var, value())
    return
  elseif typ == "table" then
    value = table.concat(value)
  else
    value = ""
  end
  NSSetStrValue(var, value)
end

function getstr(var)
  return NSGetStrValue(var)
end

function parse_string(script)
  local pos = 2
  local str = ""
  while pos <= #script and script:sub(pos, pos) ~= '"' do
    -- }`oCg
    if script:byte(pos) > 127 then
      pos = pos + 2
    else
      pos = pos + 1
    end
  end
  return script:sub(1, pos), parse_command, script:sub(pos + 1, #script)
end

function parse_comment(script)
  local pos = 1
  while pos <= #script and script:byte(pos) ~= 0x0a do
    pos = pos + 1
  end
  return "", parse_command, script:sub(pos, #script)
end

function parse_asis(script)
  local pos = 2
  local str = ""
  while pos <= #script and script:sub(pos, pos) ~= '`' do
    -- }`oCg
    if script:byte(pos) > 127 then
      pos = pos + 2
    else
      pos = pos + 1
    end
  end
  return script:sub(2, pos-1), parse_command, script:sub(pos + 1, #script)
end

function parse_command(script)
  if not script then return "" end
  if #script == 0 then return "" end
  local first = script:sub(1, 1)
  if script:byte(1) > 127 then
    return "", parse_text, script
  elseif first == ';' then
    return "", parse_comment, script
  elseif first == ':' then
    return ";", parse_command, script:sub(2, #script)
  elseif first == '\r' or first == '\n' then
    return first, parse_command, script:sub(2, #script)
  elseif first == '\\' then
    return [[nscr.execute('puttext "]] .. first .. [["')]], parse_command, script:sub(2, #script)
  elseif first == '@' then
    return [[nscr.execute('puttext "]] .. first .. [["')]], parse_command, script:sub(2, #script)
  elseif first == '`' then
    return parse_asis(script)
  else
    local command = ""
    local buffer = script
    local feedlen = 0
    while true do
      -- ؂AꕶA񃊃e܂
      local str = buffer:match('^[^;:%"`\r\n%\@]+')
      if not str then break end
      feedlen = feedlen + #str
      command = command .. str
      -- 񃊃ȅꍇ̓R}hɊ܂߂B
      first = script:sub(feedlen+1, feedlen+1)
      if first == '"' then
        -- eɃobNNH[g͎gpłȂB
        str = parse_string(script:sub(feedlen+1, #script))
        feedlen = feedlen + #str
        command = command .. str:gsub("`", "")
      -- sLuaXNvg܂߂B
      elseif first == '`' then
        str = parse_asis(script:sub(feedlen+1, #script))
        feedlen = feedlen + #str + 2 -- obNNH[g폜ZB
        command = command .. str
      else
        break
      end
      buffer = script:sub(feedlen+1, #script)
    end
    if command:match("^[ \t]+$") then
      -- 󔒂Ȃꍇ͖B
      return "", parse_command, script:sub(feedlen+1, #script)
    end
    return [[nscr.execute(']] .. command .. [[')]], parse_command, script:sub(feedlen+1, #script)
  end
end

function parse_text(script, begin)
  if not script then return "" end
  local pos = begin or 1
  while pos < #script and script:byte(pos) > 127 do
    pos = pos + 2
  end
  -- ꕶ
  if pos <= #script then
    local char = script:sub(pos, pos)
    if char == "\\" or char == "@" then
      return parse_text(script, pos+1)
    end
  end
  -- ŏIʒu̕}`oCgꍇ̏
  if pos == #script and script:byte(pos) > 127 then
    pos = pos + 1
  end
  return [[nscr.execute(']] .. script:sub(1, pos-1) .. [[')]], parse_command, script:sub(pos, #script)
end

function parse(script)
  local result = ""
  parser = parse_command
  local buffer = ""
  while parser do
    buffer, parser, script = parser(script)
    result = result .. buffer
    NSSleep(1)
    if NSDoEvents() then return "" end
  end
  return result
end

function eval(script)
  -- loadstring()ł́AGXP[vLN^lĂȂ2dɂB
  assert(loadstring(parse(script):gsub("\\", "\\\\")))()
end

function load(filename)
  local org = NSGetStrValue(0)
  NSExec('readfile $0,"' .. filename .. '"')
  local text = NSGetStrValue(0)
  NSSetStrValue(0, org)
  eval(text)
end

function mementint(beg, count)
  count = count or 1
  step = count < 0 and -1 or 1
  if not beg or type(beg) ~= "number" or (beg + count - step) < 0 then
    errobj = {
      type = __nscrerror__,
      msg = "ۑΏۂ̕ϐԍ܂B",
      callee = debug.getinfo(2, "Slnf")
    }
    error(errobj, 0)
  end
  for var=beg, beg+count-step, step do
    vars.int[tostring(var)] = NSGetIntValue(var)
  end
end

function mementstr(beg, count)
  count = count or 1
  step = count < 0 and -1 or 1
  if not beg or type(beg) ~= "number" or (beg + count - step) < 0 then
    errobj = {
      type = __nscrerror__,
      msg = "ۑΏۂ̕ϐԍ܂B",
      callee = debug.getinfo(2, "Slnf")
    }
    error(errobj, 0)
  end
  for var=beg, beg+count-step, step do
    vars.str[tostring(var)] = NSGetStrValue(var)
  end
end

function mement(beg, count)
  count = count or 1
  step = count < 0 and -1 or 1
  if not beg or type(beg) ~= "number" or (beg + count - step) < 0 then
    errobj = {
      type = __nscrerror__,
      msg = "ۑΏۂ̕ϐԍ܂B",
      callee = debug.getinfo(2, "Slnf")
    }
    error(errobj, 0)
  end
  for var=beg, beg+count-step, step do
    vars.int[tostring(var)] = NSGetIntValue(var)
    vars.str[tostring(var)] = NSGetStrValue(var)
  end
end

function rememberint(beg, count)
  count = count or 1
  step = count < 0 and -1 or 1
  if not beg then
    for var, value in pairs(vars.int) do
      NSSetIntValue(tonumber(var), value)
    end
    return
  elseif type(beg) ~= "number" or (beg + count - step) < 0 then
    errobj = {
      type = __nscrerror__,
      msg = "AΏۂ̕ϐԍ܂B",
      callee = debug.getinfo(2, "Slnf")
    }
    error(errobj, 0)
  end
  for var=beg, beg+count-step, step do
    NSSetIntValue(var, vars.int[tostring(var)])
  end
end

function rememberstr(beg, count)
  count = count or 1
  step = count < 0 and -1 or 1
  if not beg then
    for var, value in pairs(vars.str) do
      NSSetStrValue(tonumber(var), value)
    end
    return
  elseif type(beg) ~= "number" or (beg + count - step) < 0 then
    errobj = {
      type = __nscrerror__,
      msg = "AΏۂ̕ϐԍ܂B",
      callee = debug.getinfo(2, "Slnf")
    }
    error(errobj, 0)
  end
  for var=beg, beg+count-step, step do
    NSSetStrValue(var, vars.str[tostring(var)])
  end
end

function remember(beg, count)
  count = count or 1
  step = count < 0 and -1 or 1
  if not beg then
    for var, value in pairs(vars.int) do
      NSSetIntValue(tonumber(var), value)
    end
    for var, value in pairs(vars.str) do
      NSSetStrValue(tonumber(var), value)
    end
    return
  elseif type(beg) ~= "number" or (beg + count - step) < 0 then
    errobj = {
      type = __nscrerror__,
      msg = "AΏۂ̕ϐԍ܂B",
      callee = debug.getinfo(2, "Slnf")
    }
    error(errobj, 0)
  end
  for var=beg, beg+count-step, step do
    NSSetIntValue(var, vars.int[tostring(var)])
    NSSetStrValue(var, vars.str[tostring(var)])
  end
end
