
require "lunit"



module("string_joinp", package.seeall, lunit.testcase)

function setup()
  NSSetStrValue(0, "")
end

function teardown()
  NSSetStrValue(0, "")
end

-- joinp $0, "sep", pat ; patA"sep"Ɗ֌WȂA㑱񂪖ꍇ͋󕶎ݒ肷B
function testSetEmptyIfNoParameters()
  NSExec('joinp $0,",",s')
  assert_equal("", NSGetStrValue(0))
end

-- joinp $0, "sep", pat, ... ; patɏ]Č㑱̒Pꕶ擾B
function testCanJoinSingleString()
  NSExec('joinp $0,",",s,"P"')
  assert_equal("P", NSGetStrValue(0))
end

-- joinp $0, "sep", pat, ... ; patɏ]Č㑱̕擾A"sep"ŘAB
function testCanJoinMultiStrings()
  NSExec('joinp $0,",",s,"P","Q","R"')
  assert_equal("P,Q,R", NSGetStrValue(0))
end

-- joinp $0, "sep", pat, ... ; patɏ]Č㑱̒Pꐔl擾B
function testCanJoinSingleInteger()
  NSExec('joinp $0,",",i,1')
  assert_equal("1", NSGetStrValue(0))
end

-- joinp $0, "sep", pat, ... ; patɏ]Č㑱̕l擾A"sep"ŘAB
function testCanJoinMultiInteger()
  NSExec('joinp $0,",",i,1,2,3')
  assert_equal("1,2,3", NSGetStrValue(0))
end

-- joinp $0, "sep", pat, ... ; patɏ]Č㑱̃p^[菭Ȃp[^擾B
function testCanJoinLessParameters()
  NSExec('joinp $0,",",si,"P"')
  assert_equal("P", NSGetStrValue(0))
end

-- joinp $0, "sep", pat, ... ; patɏ]Č㑱̃p^[葽p[^擾A"sep"ŘAB
function testCanJoinMoreParameters()
  NSExec('joinp $0,",",is,1,"P",2,"Q"')
  assert_equal("1,P,2,Q", NSGetStrValue(0))
end

-- joinp $0, "sep", pat, ... ; patɏ]Č㑱̕f[^擾A"sep"ŘAA"sep"ŘAB
function testCanJoinMultiParameters()
  NSExec('joinp $0,",",ssiisiis,"P","Q",1,2,"R",3,4,"S"')
  assert_equal("P,Q,1,2,R,3,4,S", NSGetStrValue(0))
end

